/*
 * (C) Copyright 2007-2013
 * Allwinner Technology Co., Ltd. <www.allwinnertech.com>
 * Jerry Wang <wangflord@allwinnertech.com>
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#include <private_uboot.h>

struct spare_boot_head_t  uboot_spare_head = {
	                                  {
	      /* jump_instruction */          ( 0xEA000000 | ( ( ( sizeof( struct spare_boot_head_t ) + sizeof( int ) - 1 ) / sizeof( int ) - 2 ) & 0x00FFFFFF ) ),
							   		      UBOOT_MAGIC,
							   		      STAMP_VALUE,
							   		      ALIGN_SIZE,
							   		      0,
							   		      0,
							   		      UBOOT_VERSION,
							   		      UBOOT_PLATFORM,
							   		      {CONFIG_SYS_TEXT_BASE}
							 	      },
							 	      {
										  { 0 },		//dram para
							 	      	  1008,			//run core clock
							 	      	  1200,			//run core vol
							 	      	  0,			//uart port
							 	      	  {             //uart gpio
							 	      	    //{0}, {0}
							 	      	    { 2, 0, 3, 1, 1, 0, },
										  	{ 2, 1, 3, 1, 1, 0, }
										  },
							 	      	  0,			//twi port
							 	      	  {             //twi gpio
							 	      	  	{0}, {0}
		                                  },
							 	      	  0,			//work mode
							 	      	  0,			//storage mode
							 	      	  { {0} },		//nand gpio
							 	      	  { 0 },		//nand spare data
							 	      	  { {0} },		//sdcard gpio
							 	      	  { 0 }, 		//sdcard spare data
							 	      	  { 0 }			//reserved data
							 	      }
							 	  };


/*******************************************************************************
*
*                  Boot_file_headеjump_instructionֶ
*
*  jump_instructionֶδŵһתָ( B  BACK_OF_Boot_file_head )
*תָִк󣬳תBoot_file_headһָ
*
*  ARMָеBָ£
*          +--------+---------+------------------------------+
*          | 31--28 | 27--24  |            23--0             |
*          +--------+---------+------------------------------+
*          |  cond  | 1 0 1 0 |        signed_immed_24       |
*          +--------+---------+------------------------------+
*  ARM Architecture Reference Manualڴָ½ͣ
*  Syntax :
*  B{<cond>}  <target_address>
*    <cond>    Is the condition under which the instruction is executed. If the
*              <cond> is ommitted, the AL(always,its code is 0b1110 )is used.
*    <target_address>
*              Specified the address to branch to. The branch target address is
*              calculated by:
*              1.  Sign-extending the 24-bit signed(wro's complement)immediate
*                  to 32 bits.
*              2.  Shifting the result left two bits.
*              3.  Adding to the contents of the PC, which contains the address
*                  of the branch instruction plus 8.
*
*  ɴ˿ָ֪8λΪ0b1110101024λBoot_file_headĴС
*̬ɣָװ£
*  ( sizeof( boot_file_head_t ) + sizeof( int ) - 1 ) / sizeof( int )    ļͷ
*                                              ռõġ֡ĸ
*  - 2                                         ȥPCԤȡָ
*  & 0x00FFFFFF                                signed-immed-24
*  | 0xEA000000                                װBָ
*
*******************************************************************************/
